% ce fichier permet de lancer le programme sur tous les fichiers texte

dynamic :- textname/1.

:-[extract_info].

% ef(+FichierConstat).

ef(X) :- ecrit_fichiers(X).


ecrit_fichiers(Text) :- 
	write(Text), nl,
	assert(n_id(0)),
	asserta(text_name(Text)),
	i, % trouve tout !
	concat_atom([Text, '.ad'],' ', Out),
	nl, write( 'criture du fichier ...'),
	write(Text), nl,
	tell(Out),
	write_statics,
	write_dynamics,
	write_accidents,
	% il reste a ecrire les collisions
	told,!,
	write('Termin '), nl,
	retract(text_name(Text)),
	abolish_dynamic_preds.

ecrit_fichiers(Text) :-
	nl, write('chec lors de la creation de '), write(Text),
	nl.

menu :-
	nl, write('MENU '), nl,
	write(' choisir un texte : ie. '), nl,
	write(' trouver les infos : i.'), nl,
	write(' sortir un fichier : ef(Nomdutexte). '), nl,
	nl.


stat :-
	tous_les_textes(A),
	compile_corpus(A).

compile_corpus([Text|Rest]) :-
	ecrit_fichiers(Text),
	compile_corpus(Rest).

compile_corpus([]).

stat_chocs :-
	tous_les_textes(A),
	tell('statistiques chocs.txt'),
	
	chocs_corpus(A, 0, Nchocs),
	write('J''ai trouv '),write(Nchocs),write(' chocs dans les textes'),nl,
	told,
	write('J''ai trouv '),write(Nchocs),write(' chocs dans les textes'),nl.

chocs_corpus([Text|Rest],N, Nchocs) :-
	
	asserta(text_name(Text)),
	write_ln(Text),
	trouve_tout( _, SortieChocs, _ ),
	%write_ln(ListeActeurs),
	write_ln(SortieChocs),
	augmente_stats(N,M,SortieChocs),
	chocs_corpus(Rest,M, Nchocs).

chocs_corpus([],Nchocs,Nchocs).

stat_events :-
	tous_les_textes(A),
	tell('statistiques events.txt'),
	
	events_corpus(A, 0, Nevents),
	write('J''ai trouv '),write(Nevents),write(' events dans les textes'),nl,
	told,
	write('J''ai trouv '),write(Nevents),write(' events dans les textes'),nl.

events_corpus([Text|Rest],N, Nevents) :-
	
	asserta(text_name(Text)),
	write_ln(Text),
	trouve_tout( _, _, Sortieevents),
	%write_ln(ListeActeurs),
	write_ln(Sortieevents),
	augmente_stats(N,M,Sortieevents),
	events_corpus(Rest,M, Nevents).

events_corpus([],Nevents,Nevents).

augmente_stats(N,N,[]). % augmentation des stats si la liste n'est pas vide
augmente_stats(N,M,_):- M is N + 1.

tous_les_textes([/*
		'texte a1.txt','texte a2.txt',
		'texte a3.txt','texte a4.txt',
		'texte a5.txt',
		%
		'texte a7.txt','texte a8.txt',
		'texte a9.txt','texte a10.txt',
		'texte a11.txt','texte a12.txt',
		'texte a13.txt','texte a14.txt',
		'texte a15.txt',%
		'texte a17.txt',
		'texte b1.txt','texte b1-bis.txt',
		'texte b2.txt',%'texte b2-bis.txt',
		'texte b3.txt','texte b4.txt',
		'texte b5.txt','texte b6.txt',
		'texte b7.txt','texte b8.txt',
		'texte b9.txt',
		'texte b10.txt','texte b11.txt',
		'texte b12.txt','texte b13.txt',
		'texte b14.txt','texte b15.txt',
		'texte b17.txt',
		'texte b18.txt','texte b19.txt',
		'texte b20.txt','texte b21.txt',
		'texte b22.txt','texte b23.txt',
		'texte b24.txt','texte b25.txt',
		'texte b26.txt',
		'texte b28.txt','texte b29.txt',
		'texte b30.txt','texte b31.txt',
		'texte b32.txt','texte b33.txt',
		'texte b34.txt',
		'texte b36.txt',
		'texte b38.txt','texte b39.txt',
		'texte b40.txt','texte b41.txt',
		'texte b43.txt',
		'texte b44.txt','texte b45.txt',
		'texte b46.txt','texte b47.txt',
		'texte b48.txt','texte b49.txt',
		'texte b50.txt',
		'texte b52.txt','texte b53.txt',
		'texte b54.txt','texte b55.txt',
		'texte b56.txt','texte b57.txt',
		'texte b60.txt','texte b61.txt',
		'texte b62.txt','texte b63.txt',
		'texte b65.txt',*/
		'texte b68.txt','texte b69.txt',
		'texte b70.txt','texte b71.txt',
		'texte b72.txt','texte b73.txt',
		'texte a6.txt',
		'texte a16.txt','texte b37.txt',
		'texte b58.txt','texte b35.txt'
		%'texte b16.txt',%'texte b27.txt','texte b66.txt',
		]).



:- menu.
