read_file(File, List) :-
	see(File),
	read_list(List),
	seen,
	see(user),
	!.

read_list([X | List]) :-
	get0(X),
	X =\= -1,
	!,
	read_list(List).
read_list([]).


% The classical quicksort(+InputList, -SortedList)

quicksort([], []) :- !.
quicksort([X | LI], LO) :-
	split(X, LI, LSmall, LBig),
	quicksort(LSmall, LSmallSorted),
	quicksort(LBig, LBigSorted),
	append(LSmallSorted, [X | LBigSorted], LO).
	
split(X, [Y | L], [ Y | LSmall], LBig) :-
	before(Y, X),
	!,
	split(X, L, LSmall, LBig).
split(X, [Y | L], LSmall, [Y | LBig]) :-
	!,
	split(X, L, LSmall, LBig).
split(_, [], [], []) :- !.

before(X, Y) :- X @< Y.

count_duplicates(OrderedList, CountedList) :-
	count_duplicates(OrderedList, 1, [], CountedListRev),
	reverse(CountedListRev, CountedList).

count_duplicates([X, X | Ordered], N, Counting, Counted) :-
	N1 is N + 1,
	count_duplicates([X | Ordered], N1, Counting, Counted).
count_duplicates([X | Ordered], N, Counting, Counted) :-
	count_duplicates(Ordered, 1, [[N, X] | Counting], Counted).
count_duplicates([], _, L, L).


%-----------------------------------------------------------------------------
% Teste si un mot de la liste de mots donne en 2e arg
% est present dans la liste du 1er arg
contains_word(L1, L2) :-
	member(X, L1),
	member(X, L2).

contains_word2(L1, L2, X) :-
	member(X, L1),
	member(X, L2).









